<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\Controller;

use Dedi\SyliusMarketingPlugin\Events\EventInterface;
use Dedi\SyliusMarketingPlugin\Storage\EventStorageInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;

class FetchEventController extends AbstractController
{
    private EventStorageInterface $eventStorage;

    public function __construct(EventStorageInterface $eventStorage)
    {
        $this->eventStorage = $eventStorage;
    }

    public function fetch(Request $request): JsonResponse
    {
        $eventName = $request->request->get('dedi_sylius_marketing_async_event', '');
        $events = array_filter($this->eventStorage->getAsyncEvents(), static fn (EventInterface $event) => $event->getName() === $eventName);

        return $this->json($events);
    }
}
